Package org.apache.ignite.internal.processors.cache.persistence.tree

## Interface BPlusTree.TreeRowClosure<L,​T extends L>

All Known Implementing Classes:
  `InlineObjectBytesDetector`, `InlineTreeFilterClosure`

Enclosing class:
  BPlusTree<L,​T extends L>

    public static interface BPlusTree.TreeRowClosure<L,​T extends L>

A generic visitor-style interface for performing filtering/modifications/miscellaneous operations on the tree.

### Method Summary

All Methods Instance Methods Abstract Methods Default Methods
`boolean` `apply​(BPlusTree<L,​T> tree, BPlusIO<L> io, long pageAddr, int idx)` Performs inspection or operation on a specified row and returns true if this row is required or matches or /operation successful (depending on the context).
`default L` `lastRow()` Optional operation to provide access to the last analyzed row.

### Method Detail

#### apply

    boolean apply​(BPlusTree<L,​T> tree,
                  BPlusIO<L> io,
                  long pageAddr,
                  int idx)
           throws IgniteCheckedException

Performs inspection or operation on a specified row and returns true if this row is required or matches or /operation successful (depending on the context).

Parameters:
  `tree` - The tree.
  `io` - Th tree IO object.
  `pageAddr` - The page address.
  `idx` - The item index.
Returns:
  `True` if the item passes the predicate.
Throws:
  `IgniteCheckedException` - If failed.

#### lastRow

    default L lastRow()

Optional operation to provide access to the last analyzed row. Can be used to optimize chained filters and omit several tree reads.

Returns:
  Last row that was analyzed or `null`.